﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Matice
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        /* Specifikace konstanty pro maximální vertikální (počet řádků) a horizontální
        * (počet sloupců) rozměr matice - inicializace */
        const int Max = 10;
        // Aktuální rozměr pole - počet řádků
        private int pocetRadku;
        // Aktuální rozměr pole - počet sloupců
        private int pocetSloupcu;
        // Přípustná minimální hodnota (dolní mez) prvku - inicializace
        private int minHodnota = 1;
        // Přípustná maximální hodnota (horní mez) prvku - inicializace
        private int maxHodnota = 100;

        // Deklarace dvourozměrného pole - matice
        private int[,] pole;

        /// <summary>
        /// Inicializace atributů pole a prvků na formuláři
        /// </summary>
        private void Inicializace()
        {
            // Přiřazení maximálního počtu řádků matice do datové složky 
            this.pocetRadku = Max;

            // Přiřazení maximálního počtu sloupců matice do datové složky 
            this.pocetSloupcu = Max;

            // Vytvoření instance (objektu) matice s definovanými rozměry
            this.pole = new int[this.pocetRadku, this.pocetSloupcu];

            // Přiřazení počtu řádků matice do objektu na formuláři 
            this.TxtPocetRadku.Text = this.pocetRadku.ToString();

            // Přiřazení počtu sloupců matice do objektu na formuláři 
            this.TxtPocetSloupcu.Text = this.pocetSloupcu.ToString();

            /* Přiřazení přípustné minimální hodnoty prvku v matici do objektu 
                * na formuláři určujícího mezní hodnotu */
            this.TxtMinHodnota.Text = this.minHodnota.ToString();

            /* Přiřazení přípustné maximální hodnoty prvku v matici do objektu (pole) 
                * na formuláři určujícího mezní hodnotu */
            this.TxtMaxHodnota.Text = this.maxHodnota.ToString();
        }


        public MainWindow()
        {
            InitializeComponent();
            Inicializace();
        }

        Random rnd = new Random();

        void NahodnePole()
        {
            for (int i = 0; i < pocetRadku; i++)
                for (int j = 0; j < pocetSloupcu; j++)
                {
                    pole[i, j] = rnd.Next(minHodnota, maxHodnota + 1);
                }
        }

        private void BtnNahodne_Click(object sender, RoutedEventArgs e)
        {
            NahodnePole();
           // MessageBox.Show(pole[0, 0].ToString());
        }

        string PoleJakoText()
        {
            string vystup = "";

            for (int i = 0; i < pocetRadku; i++)  //pole.GetLength(0)
            {
                for (int j = 0; j < pocetSloupcu; j++)
                {
                    //pridavat prvky do textu
                    vystup = vystup + pole[i, j].ToString("D3") + " ";
                }
                vystup = vystup + "\n";
               // vystup += Environment.NewLine;
            }

            return vystup;
        }


        private void BtnJakoText_Click(object sender, RoutedEventArgs e)
        {
            TxtVysledek.Text = PoleJakoText();
        }

        void ZobrazitVListView ()
        {
            LstMatice.Items.Clear();
            string radka;

            for (int i = 0; i < pocetRadku; i++)
            {
                radka = "";

                for (int j = 0; j < pocetSloupcu; j++)
                    radka += pole[i, j].ToString("D3") + " ";

                LstMatice.Items.Add(radka);
            }

        }

        private void BtnDoMrizky_Click(object sender, RoutedEventArgs e)
        {
            ZobrazitVListView();
        }
    }
}
